<?php
/*Plugin now for Joomla4 by https://jnofollow.com/
 *from Alexander Mueller - SEO NW ( new Script for J4!)
 *The GNU General Public License is a free, copyleft license for
 *software and other kinds of works.
 *@license https://www.gnu.org/copyleft/gpl.html GNU/GPL
 *
 * A plugin that allows you to add rel="nofollow" on all external link
 * Plugin for Joomla 2.5 and Joomla 3.x Version 1.4 ( deprecated ) this Script only runs on Joomla4!
 * License: http://www.gnu.org/copyleft/gpl.html
 * Authors: marco maria leoni
 * Copyright (c) 2010 - 2014 marco maria leoni web consulting - http: www.mmleoni.net
 * 
 * *** Last update: 11.11, 2021 ***
*/


// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

//modifiziert
use Joomla\String\StringHelper;


class plgContentnofollow extends JPlugin{

	public function onContentPrepare($context, &$article, &$params, $page = 0){
		if (is_object($article)){
			return $this->setNofollow($article->text, $params);
		}
		return $this->setNofollow($article, $params);
	}
	
	private function whitelistPrepare($val) {
			$val = trim($val);
			
			// remove trailing slash because domain.de and domain.de/ are diffrent strings but same locations
			$val = rtrim($val, '/');

			// convert to lowercase
			$val = strtolower($val);
	     	
			// remove schema
			$val = preg_replace("/https?:\/\//i", '', $val);
          	
			return $val;
		}

	private function setNofollow(&$text, &$params){
		/*
		 * Check for presence of {mnf=off} which is explicits disables this
		 * bot for the item.
		 */
		
		if (StringHelper::strpos($text, '{mnf=off}') !== false) {
			$text = StringHelper::str_ireplace('{mnf=off}', '', $text);
			return true;
		}

		// Load plugin params info
		$mode = $this->params->get('mode');
		$attribsModeStrict = $this->params->get('attribsModeStrict', 0);
		$target = $this->params->get('target');
		$applyMethod = $this->params->get('applymethod', 'ALL');
		if($this->params->get('classeslist')){
			$classesList = explode(',', preg_replace('/\s*/', '', $this->params->get('classeslist')));
		}else{
			$classesList = array();
		}
		$whitelist = $this->params->get('whitelist');
		
		$whitelist = trim($whitelist);
		$whitelist = explode("\n", $whitelist);
		$whitelist = array_filter($whitelist, 'trim');
		$whitelist = array_map('self::whitelistPrepare', $whitelist);
		
		//echo 'final whitelist <pre>'.htmlspecialchars(print_r($whitelist, true)).'</pre>';
		
		/* $pattern = "/<a((\s+(\w|\w[\w-]*\w)(\s*=\s*(?:\".*?\"|'.*?'|[^'\">\s]+))?)+\s*|\s*)\/?>/i"; */
		$tags = array( 'a' => '/<a\s+([^>]*)>/i', 'area' => '/<area\s+([^>]*)>/i' );
		foreach($tags as $tag => $pattern){
			$links = array();
			preg_match_all( $pattern, $text, $links, PREG_SET_ORDER );

			foreach ($links as $link){
				$pattern = "/(\w+)(\s*=\s*(?:\".*?\"|'.*?'|[^'\">\s]+))?/i"; // get attributes
				$attribs = array();
				preg_match_all ( $pattern, $link[1], $attribs, PREG_SET_ORDER );
				
				$list = array();
				foreach ($attribs as $attrib){
					if (!isset($attrib[2])) continue; // something wrong, may be js in email cloaking plugin
					if(!$attribsModeStrict){ //relaxed
						$list[strtolower($attrib[1])] = preg_replace("/=\s*[\"']?([^'\"]*)[\"']?/", "$1", $attrib[2]);
					}else{ //strict
						$list[strtolower($attrib[1])] = preg_replace("/=\s*(?:\"([^\"]*)\")|(?:'([^']*)')/", "$1", $attrib[2]);
					}
				}
				
				// skip if non http link or anchor
				if (!isset($list['href'])) continue;
				if (stripos($list['href'], 'http') !== 0) continue;
				$href = preg_replace("/https?:\/\//i", '', $list['href']);

				// skip if internal link
				if (stripos($href, $_SERVER['SERVER_NAME']) === 0) continue;
				
				// skip whitelisted
				if(!empty($whitelist)) {
					$href_compare = rtrim($href, '/');
					$href_compare = strtolower($href_compare);
					
					// - skip exact match
					if (in_array($href_compare, $whitelist)) {
						//echo '<p>skip exact match: '.$href_compare.'</p>';
						continue;
					}
					
					// - skip wildcard match
					$skip = false;
					
					foreach($whitelist AS $whitelisted) {
						
						if(strpos($whitelisted, '*') !== 0 AND $skip === false) {
							$whitelisted = rtrim($whitelisted, '*/');
							
							if(preg_match('#^'.preg_quote($whitelisted).'*#i', $href_compare) !== 0) {
								//echo '<p>skip wildcard match: '.$whitelisted.': found in: '.$href_compare.'</p>';
								$skip = true;
								break;
							}
						}
					}
					
					if($skip === true) continue;
				}

				
				//get classes
				if(!empty($list['class'])){
					$linkClasses = preg_split('/\s+/', $list['class']);
				}else{
					$linkClasses = array();
				}

				if(array_intersect($linkClasses, $classesList)){
					//link classes are present in classes list
					if($applyMethod=='ALL') continue;
				}else{
					if($applyMethod=='NONE') continue;
				}
				
				if( ($mode == 0) && !isset($list['rel']) ){
					$list['rel'] = 'nofollow noopener noreferrer';
				}else if ($mode==1)	{
					$list['rel'] = 'nofollow noopener noreferrer';
				}else if ($mode==2)	{
					unset($list['rel']);
				}
				
				if( ($target == 0) && !isset($list['target']) ){
					$list['target'] = "_blank";
				}else if ($target == 1){
					$list['target'] = "_blank";			
				}else if ($target == 2){
					$list['target'] = "_parent";
				}
				
				$ahref = "<$tag ";
				foreach ($list as $k=>$v){
					$ahref .= "{$k}=\"{$v}\" ";
				}
				$ahref .= '>';
				
				$text = str_replace($link[0], $ahref, $text);
				
			}
		}
		return true;
	}
}
?>